package kr.co.mkblog.mkblogopenglesexample;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Matrix;
import android.opengl.GLES30;
import android.opengl.GLUtils;
import android.util.Log;

public class mkTextureLoader {

    public int textureID[];

    public mkTextureLoader(Context inputContext, String fileName, int sTextureParameter, int tTextureParameter){
        Bitmap tmpBitmap, textureBitmap;
        BitmapFactory.Options texOption = new BitmapFactory.Options();
        texOption.inScaled = false;
        int inputId = inputContext.getResources().getIdentifier(fileName, "drawable", inputContext.getPackageName());
        if(inputId != 0) {
            tmpBitmap = BitmapFactory.decodeResource(inputContext.getResources(), inputId, texOption);
            //MK: Image Y-축으로 Flip하는 코드 추가 (모든 Texture은 Flip함)
            Matrix matrix = new Matrix();
            matrix.preScale(1.0f, -1.0f);
            textureBitmap  = Bitmap.createBitmap(tmpBitmap, 0, 0, tmpBitmap.getWidth(), tmpBitmap.getHeight(), matrix, true);
        }
        else{
            Log.d("mkTextureLoader:", "(Error) Loading Texture File to Bitmap");
            return;
        }
        textureID = new int[1];
        GLES30.glGenTextures(1, textureID, 0);
        GLES30.glBindTexture(GLES30.GL_TEXTURE_2D, textureID[0]);
        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_WRAP_S, sTextureParameter);
        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_WRAP_T, tTextureParameter);

        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_MIN_FILTER, GLES30.GL_LINEAR);
        GLES30.glTexParameteri(GLES30.GL_TEXTURE_2D, GLES30.GL_TEXTURE_MAG_FILTER, GLES30.GL_LINEAR);
        GLUtils.texImage2D(GLES30.GL_TEXTURE_2D, 0, textureBitmap, 0);
        GLES30.glGenerateMipmap(GLES30.GL_TEXTURE_2D);
        Log.d("mkTextureLoader:", "(Good) Ready to use texture");
    }
}